/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include "app_LED.h"

void HandleLeds(void)
{
    static uint8        ledState        = LED_OFF;
    static uint32       scanLedTimer    = SCAN_LED_TIMEOUT;   
    static uint32       connLedTimer    = CONN_LED_TIMEOUT;   
    
    switch (cyBle_state)
    {
        case CYBLE_STATE_SCANNING:
            
            Conn_LED_Write(LED_OFF);
            
            if(--scanLedTimer == 0u) 
            {
                scanLedTimer = SCAN_LED_TIMEOUT;
                ledState ^= LED_OFF;
                
                Scan_LED_Write(ledState);
            }
            
            break;
            
        case CYBLE_STATE_CONNECTED: 
            
            Scan_LED_Write(LED_OFF);
            
            if(--connLedTimer == 0u) 
            {
                connLedTimer = CONN_LED_TIMEOUT;
                ledState    ^= LED_OFF;
                
                Conn_LED_Write(ledState);
            }
            
        default:
            break;
    }
}

/* [] END OF FILE */
